require('dotenv').config();
const mysql = require('mysql');
const moment = require('moment');
const crypto = require('crypto');

// console.log(process.env.PORT);
const mysqlcon = mysql.createConnection({
    host: process.env.DB_HOST,
    user: process.env.DB_USERNAME,
    database: process.env.DB_NAME,
    password: process.env.DB_PASSWORD
  });

  // Database  connection 
  mysqlcon.connect((err) => {
    if (err) {
      console.error('Database  connection error:', err);
      return;
    }
   // console.log('Database connected!');
  });
  
module.exports = {

  //========================================== get user details function start =========================================
async  getUserDetails(user_id) {
  // console.log('user_id',user_id);
     return new Promise((resolve, reject) => {

        mysqlcon.query(
      'SELECT  `login_type`, `login_type_first`, `privileges`, `privileges_subadmin`, `user_type`,' +
      '`add_by_type`, `test_status`, `email`, `password`, `mobile`, `phone_code`, `f_name`, `l_name`, `name`,' +
      '`user_name`, `dob`, `age`, `image`, `gender`, `address`, `latitude`, `longitude`, `state_id`, `city_id`,' +
      '`zipcode`, `bio`, `language_id`, `facebook_id`, `google_id`, `twitter_id`, `instagram_id`, `apple_id`,' +
      '`location_status`, `notification_status`, `otp`, `otp_verify`, `active_flag`,`signup_step`,`approve_flag`,' +
      '`profile_complete`, `delete_flag`, `delete_reason`, `device_id`, `country_id`, `country_name`, `about_me`, ' +
      '`availability_status`, `driver_status`, `owner_id`, `owner_name`, `owner_mobile`, `emergency_mobile_1`,' +
      '`emergency_mobile_2`, `updatetime`, `createtime`' +
      ' FROM `user_master` WHERE  user_id = ?',
      [user_id], function (err, result, fields) {


        if (err) {
          console.log('data base error in user details get ',err)
            reject( "NA");
          }
        if (!result || result.length === 0) {
            resolve ("NA");
          } else{

            const {
            login_type, login_type_first, privileges, privileges_subadmin, user_type, add_by_type, test_status, email, password, mobile, phone_code, f_name, l_name, name, user_name, dob, age, image, gender, address, latitude, longitude, state_id, city_id, zipcode, bio, language_id, facebook_id, google_id, twitter_id, instagram_id, apple_id, location_status, notification_status, otp, otp_verify, active_flag, signup_step, approve_flag, profile_complete, delete_flag, delete_reason, device_id, country_id, country_name, about_me, availability_status, driver_status, owner_id, owner_name, owner_mobile, emergency_mobile_1, emergency_mobile_2, updatetime, createtime 
            } = result[0];

            const socialTypeArr = ['app', 'google', 'apple', 'facebook', 'twitter', 'instagram'];
            const loginType = socialTypeArr[login_type];
            const loginTypeFirst = socialTypeArr[login_type_first];

            // Check and assign default values for social IDs
            const defaultSocialId = (id) => id ? id : "NA";
            const facebookId = defaultSocialId(facebook_id);
            const googleId = defaultSocialId(google_id);
            const twitterId = defaultSocialId(twitter_id);
            const instagramId = defaultSocialId(instagram_id);
            const appleId = defaultSocialId(apple_id);

            // Handle null values for device ID and image
            const deviceId = device_id || "NA";
            const userImage = image || "NA";

            // Handle null values for date of birth and calculate age
            let userDob = "NA";
            let userAge = 0;
            if (dob && dob !== '0000-00-00') {
            userDob = moment(dob).format('DD-MM-YYYY');
            userAge = moment().diff(moment(dob, 'DD-MM-YYYY'), 'years');
            }

            // Format date of birth for display
            const dobShow = moment(userDob, 'DD-MM-YYYY').format('YYYY-MM-DD');
            const userArr = {
            user_id: user_id,
            user_type: user_type,
            login_type: loginType,
            login_type_first: loginTypeFirst,
            name: name,
            f_name: f_name,
            l_name: l_name,
            mobile: mobile,
            phone_code: phone_code,
            email: email,
            otp: otp,
            otp_verify: otp_verify,
            image: userImage,
            profile_complete: profile_complete,
            active_flag: active_flag,
            approve_flag: approve_flag,
            notification_status: notification_status,
            delete_flag: delete_flag,
            latitude: latitude,
            longitude: longitude,
            address: address,
            facebook_id: facebookId,
            google_id: googleId,
            twitter_id: twitterId,
            instagram_id: instagramId,
            apple_id: appleId,
            delete_reason: delete_reason,
            createtime: createtime,
            updatetime: updatetime,
            signup_step: signup_step,
            device_id: deviceId,
            country_id: country_id,
            country_name: country_name,
            add_by_type: add_by_type,
            test_status: test_status,
            user_name: user_name,
            gender: gender,
            state_id: state_id,
            city_id: city_id,
            zipcode: zipcode,
            location_status: location_status,
            about_me: about_me,
            availability_status: availability_status,
            driver_status: driver_status,
            owner_id: owner_id,
            owner_name: owner_name,
            owner_mobile: owner_mobile,
            emergency_mobile_1: emergency_mobile_1,
            emergency_mobile_2: emergency_mobile_2,
            age: userAge,
            dob: userDob,
            bio: bio,
            language_id: language_id,
            dob_show: dobShow,
            privileges_subadmin: privileges_subadmin,
            privileges: privileges,
            status: false,
            };
        // console.log('userArr',userArr);
            resolve( userArr);
          }
        });
        });
            
},
  //========================================== get user details function end =========================================
  async  checkAccountActivateDeactivate(user_id) {
    return new Promise((resolve, reject) => {
      mysqlcon.query('SELECT active_flag FROM user_master WHERE user_id = ?',
      [user_id], (error, rows) => {
          if (error) {
            console.log('database active check error',error)
            resolve('NA');
          } else {
            if (rows.length > 0) {
              const { active_flag } = rows[0];
              resolve( active_flag === '1' ? '1' : '0');
            } else {
              resolve ('0');
            } 
          }
      });
  });

  },

  async getAdminDetail() {
    return new Promise((resolve, reject) => {
      mysqlcon.query('SELECT user_id, email, name, image,mobile FROM user_master WHERE delete_flag = 0 AND user_type = 0 and profile_complete=1', (error, rows) => {
          if (error) {
            console.log('database admin check error',error)
            resolve('NA');
          } else {
            if (result.length > 0) {
              const { user_id, email, name, image,mobile } = result[0];
              const addmin_arr = { admin_id: user_id, admin_email: email, admin_name: name, admin_image:image,admin_mobile:mobile };
              resolve(addmin_arr);
            } else {
              resolve('NA');
            }
          }
      });
  });
    
  },
  
  async md5(password) {
    const hash = crypto.createHash('md5');
    hash.update(password);
    return hash.digest('hex');
},
   async  getAllUsers() {
    return new Promise((resolve, reject) => {
        mysqlcon.query('SELECT * FROM user_master', (error, rows) => {
            if (error) {
                reject(error); // Reject the promise with the error
            } else {
                resolve(rows); // Resolve the promise with the rows
            }
        });
    });
    
    },
  
    //================ check User function start ============================
  
   async  checkUserOldPassword(oldpassword,user_id) {
    return new Promise((resolve, reject) => {
   
        mysqlcon.query('SELECT user_id FROM user_master where delete_flag= 0 and user_type=0 and profile_complete=1 and BINARY password = ? and user_id = ?',[oldpassword,user_id], (error, rows) => {
            if (error) {
                console.log('database user check old pass error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.length > 0) {
                                     // Email exists, resolve with user_id
                    resolve(1); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },
    //===================content_arr ================================================
    async  getAllContent() {
      return new Promise((resolve, reject) => {
          mysqlcon.query('SELECT `content_id`, `content_type`, `content_1`, `content_2`, `delete_flag` FROM `content_master` WHERE delete_flag = 0 ', (error, rows) => {
              if (error) {
                  console.log('database content_type get all error ')
                  reject(error); // Reject the promise with the error
              } else {
                  let content_arr='';
                  if (rows.length > 0) {
                    
                      content_arr = rows;
                  }else{
                      content_arr = [];
                  }
                  resolve(content_arr); // Resolve the promise with the rows
              }
          });
      });
      
      },

//=======================================================update content 
async  updateContent(language_id,content_id,content) {
  return new Promise((resolve, reject) => {
      const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
let query = '';
if(language_id === 1){
query = 'UPDATE content_master SET content_2 = ?,updatetime=? WHERE delete_flag=0 and  content_id = ? ';
}else{
query = 'UPDATE content_master SET content_1 = ?,updatetime=? WHERE delete_flag=0 and  content_id = ? ';
}
      mysqlcon.query(query,[content,updatetime,content_id], (error, rows) => {
          if (error) {
              console.log('database update content error ')
              reject(error);       // Reject the promise with the error
          } else {
              if (rows.affectedRows > 0) {
                                   // Email exists, resolve with user_id
                  resolve(rows.affectedRows); // Resolve with user_id
              } else {
                                    // Email does not exist, resolve with 0
                  resolve(0);       // Resolve with 0
              }
          }
      });
  });
  
  },

      async  getAllContactus() {
        return new Promise((resolve, reject) => {
            mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY contact_id DESC) AS s_no,   cu.contact_id,   cu.user_id,   cu.email,cu.name,cu.mobile,cu.message,cu.subject,cu.reply_message,cu.replied_date_time,cu.status,cu.createtime,cu.type, IF(cu.user_id = 0 OR um.image IS NULL, "NA", um.image) as image  FROM  contact_us_master cu LEFT JOIN    user_master um ON cu.user_id = um.user_id  WHERE   cu.delete_flag = 0  order by contact_id desc', (error, rows) => {
                if (error) {
                    console.log('database contactus get all error ')
                    reject(error); // Reject the promise with the error
                } else {
                    let contactus_arr='';
                    if (rows.length > 0) {
                        rows.forEach(row => {
                            row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                            row.replied_date_time = moment(row.replied_date_time).format('DD-MM-YYYY h:mm A');
                            row.contact_id = Buffer.from(row.contact_id.toString()).toString('base64');    
                        //     row.dob = moment(row.dob).format('DD-MM-YYYY');
                        //     row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');                        
                        });
                        contactus_arr = rows;
                    }else{
                        contactus_arr = [];
                    }
                    resolve(contactus_arr); // Resolve the promise with the rows
                }
            });
        });
        
        },
        async  checkContactus(contact_id) {
            return new Promise((resolve, reject) => {
                
                 
                
                console.log(contact_id)
                mysqlcon.query('SELECT contact_id FROM contact_us_master where delete_flag= 0   and contact_id = ?',[contact_id], (error, rows) => {
                    if (error) {
                        console.log('database user contact_id error ')
                        reject(error);       // Reject the promise with the error
                    } else {
                        if (rows.length > 0) {
                                             // Email exists, resolve with user_id
                            resolve(rows[0].contact_id); // Resolve with user_id
                        } else {
                                              // Email does not exist, resolve with 0
                            resolve(0);       // Resolve with 0
                        }
                    }
                });
            });
            
            },
        async  deleteContactus(contact_id) {
            return new Promise((resolve, reject) => {
                const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
                query = 'DELETE FROM contact_us_master WHERE contact_id = ?';
        
                mysqlcon.query(query,[contact_id], (error, rows) => {
                    if (error) {
                        console.log('database delete contact_id error ')
                        reject(error);       // Reject the promise with the error
                    } else {
                        if (rows.affectedRows > 0) {
                                             // Email exists, resolve with user_id
                            resolve(rows.affectedRows); // Resolve with user_id
                        } else {
                                              // Email does not exist, resolve with 0
                            resolve(0);       // Resolve with 0
                        }
                    }
                });
            });
            
            },
              //=======================================================update updateFaq 
        async  updateContactus(contact_id,reply_message, subject) {
            return new Promise((resolve, reject) => {
                const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
       
                query = 'UPDATE contact_us_master SET status=1, reply_message= ?,subject = ?,replied_date_time=?,updatetime=? WHERE delete_flag=0 and  contact_id = ? ';
        
                mysqlcon.query(query,[reply_message,subject,updatetime,updatetime,contact_id], (error, rows) => {
                    if (error) {
                        console.log('database update contact_id error ')
                        reject(error);       // Reject the promise with the error
                    } else {
                        if (rows.affectedRows > 0) {
                                             // Email exists, resolve with user_id
                            resolve(rows.affectedRows); // Resolve with user_id
                        } else {
                                              // Email does not exist, resolve with 0
                            resolve(0);       // Resolve with 0
                        }
                    }
                });
            });
            
            },
        //================================ faqs ===================================
     async  getAllFaqs() {
        return new Promise((resolve, reject) => {
         
            mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY faq_id DESC) AS s_no,   `faq_id`, `faq_type`, `question`, `answer`, `question_hindi`, `answer_hindi`, `createtime`  FROM `faq_master` WHERE  delete_flag = 0  order by faq_id desc', (error, rows) => {
                if (error) {
                    console.log('database faqs get all error ')
                    reject(error); // Reject the promise with the error
                } else {
                    let faqs_arr='';
                    if (rows.length > 0) {
                        rows.forEach(row => {
                            row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                            row.faq_id = Buffer.from(row.faq_id.toString()).toString('base64');                        

                            // row.replied_date_time = moment(row.replied_date_time).format('DD-MM-YYYY h:mm A');
                                                
                        });
                        faqs_arr = rows;
                    }else{
                        faqs_arr = [];
                    }
                    resolve(faqs_arr); // Resolve the promise with the rows
                }
            });
        });
        
        },

        //================ check User function start ============================
  
async  checkFaq(faq_id) {
  return new Promise((resolve, reject) => {
      
       
      
      console.log(faq_id)
      mysqlcon.query('SELECT faq_id FROM faq_master where delete_flag= 0   and faq_id = ?',[faq_id], (error, rows) => {
          if (error) {
              console.log('database user faq_id error ')
              reject(error);       // Reject the promise with the error
          } else {
              if (rows.length > 0) {
                                   // Email exists, resolve with user_id
                  resolve(rows[0].faq_id); // Resolve with user_id
              } else {
                                    // Email does not exist, resolve with 0
                  resolve(0);       // Resolve with 0
              }
          }
      });
  });
  
  },
        
        //=======================================================update updateFaq 
        async  updateFaq(faq_type,faq_id,question, answer,question_hindi,answer_hindi) {
          return new Promise((resolve, reject) => {
              const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
     
              query = 'UPDATE faq_master SET faq_type= ?,question = ?,answer = ?,question_hindi = ?,answer_hindi = ?,updatetime=? WHERE delete_flag=0 and  faq_id = ? ';
      
              mysqlcon.query(query,[faq_type,question,answer,question_hindi,answer_hindi,updatetime,faq_id], (error, rows) => {
                  if (error) {
                      console.log('database update faq_id error ')
                      reject(error);       // Reject the promise with the error
                  } else {
                      if (rows.affectedRows > 0) {
                                           // Email exists, resolve with user_id
                          resolve(rows.affectedRows); // Resolve with user_id
                      } else {
                                            // Email does not exist, resolve with 0
                          resolve(0);       // Resolve with 0
                      }
                  }
              });
          });
          
          },
        async  addFaq(faq_type,question, answer,question_hindi,answer_hindi) {
          return new Promise((resolve, reject) => {
              const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
              const createtime = moment().format('YYYY-MM-DD HH:mm:ss');
       
      
              query = 'INSERT INTO faq_master (faq_type, question,answer,question_hindi,answer_hindi,updatetime,createtime) VALUES (?, ?,?, ?,?, ?,?)';
      
              mysqlcon.query(query,[faq_type,question,answer,question_hindi,answer_hindi,updatetime,createtime], (error, rows) => {
                  if (error) {
                      console.log('database update faq_id error ')
                      reject(error);       // Reject the promise with the error
                  } else {
                      if (rows.affectedRows > 0) {
                                  // Email exists, resolve with user_id
                          resolve(rows.insertId); // Resolve with user_id
                      } else {
                                            // Email does not exist, resolve with 0
                          resolve(0);       // Resolve with 0
                      }
                  }
              });
          });
          
          },
        async  deleteFaq(faq_id) {
          return new Promise((resolve, reject) => {
              const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');
              query = 'DELETE FROM faq_master WHERE faq_id = ?';
      
              mysqlcon.query(query,[faq_id], (error, rows) => {
                  if (error) {
                      console.log('database delete faq_id error ')
                      reject(error);       // Reject the promise with the error
                  } else {
                      if (rows.affectedRows > 0) {
                                           // Email exists, resolve with user_id
                          resolve(rows.affectedRows); // Resolve with user_id
                      } else {
                                            // Email does not exist, resolve with 0
                          resolve(0);       // Resolve with 0
                      }
                  }
              });
          });
          
          },
  };