require('dotenv').config();
const mysql = require('mysql');
const moment = require('moment');
const bcrypt = require("bcrypt");

// console.log(process.env.PORT);
const mysqlcon = mysql.createConnection({
    host: process.env.DB_HOST,
    user: process.env.DB_USERNAME,
    database: process.env.DB_NAME,
    password: process.env.DB_PASSWORD
  });

  // Database  connection 
  mysqlcon.connect((err) => {
    if (err) {
      console.error('Database se connect karne mein error:', err);
      return;
    }
    console.log('Database connected!');
  });
  
  
  
module.exports = {

  //================ default   ============================
  async   getPasswordHash(password) {
    const hash = await bcrypt.hash(password, 10);
    return hash;
  },

 //================ get all user start ============================
 async  getAllUsers() {
    return new Promise((resolve, reject) => {
        mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY user_id DESC) AS s_no,    um.user_id,    um.app_version,   um.unique_id,um.login_type,um.user_type,um.add_by_type,um.test_status,um.email,um.password,um.mobile,um.phone_code,um.f_name,um.l_name,um.name,um.user_name,um.dob,um.age,um.image,um.gender,um.address,um.latitude,um.longitude,um.state_id,um.city_id,um.zipcode,um.location_status,um.notification_status,um.otp,um.active_flag,um.profile_complete, um.approve_flag, um.createtime, um.country_id, um.country_name, um.delete_reason, IF(um.city_id = 0 OR cm.city_english IS NULL, "NA", CONCAT(cm.city_english, "(", cm.city_hindi, ")")) AS city_name,IF(um.state_id = 0 OR sm.state_english IS NULL, "NA", CONCAT(sm.state_english, "(", sm.state_hindi, ")")) AS state_name FROM  user_master um LEFT JOIN    city_master cm ON um.city_id = cm.city_id LEFT JOIN  state_master sm ON um.state_id = sm.state_id WHERE   um.delete_flag = 0  AND um.profile_complete = 2 and um.user_type=1 order by user_id desc', (error, rows) => {
            if (error) {
                console.log('database user get all error ')
                reject(error); // Reject the promise with the error
            } else {
                let user_arr='';
                if (rows.length > 0) {
                    rows.forEach(row => {
                        row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                        row.dob = moment(row.dob).format('DD-MM-YYYY');
                        // row.encode_user_id = encodeURIComponent(row.user_id);
                        row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');
                    });
                    user_arr = rows;
                }else{
                    user_arr = [];
                }
                resolve(user_arr); // Resolve the promise with the rows
            }
        });
    });
    
    },
 async  getViewUser(user_id) {
    return new Promise((resolve, reject) => {
        mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY user_id DESC) AS s_no,    um.user_id,    um.app_version,   um.unique_id,um.login_type,um.user_type,um.add_by_type,um.test_status,um.email,um.password,um.mobile,um.phone_code,um.f_name,um.l_name,um.name,um.user_name,um.dob,um.age,um.image,um.gender,um.address,um.latitude,um.longitude,um.state_id,um.city_id,um.zipcode,um.location_status,um.notification_status,um.otp,um.active_flag,um.profile_complete, um.approve_flag, um.createtime, um.country_id, um.country_name, um.delete_reason, IF(um.city_id = 0 OR cm.city_english IS NULL, "NA", CONCAT(cm.city_english, "(", cm.city_hindi, ")")) AS city_name,IF(um.state_id = 0 OR sm.state_english IS NULL, "NA", CONCAT(sm.state_english, "(", sm.state_hindi, ")")) AS state_name FROM  user_master um LEFT JOIN    city_master cm ON um.city_id = cm.city_id LEFT JOIN  state_master sm ON um.state_id = sm.state_id WHERE  um.profile_complete = 2 and um.user_type=1 and user_id = ? ', [user_id],(error, rows) => {
            if (error) {
                console.log('database user get all error ')
                reject(error); // Reject the promise with the error
            } else {
                let user_arr='';
                if (rows.length > 0) {
                    rows.forEach(row => {
                        row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                        row.dob = moment(row.dob).format('DD-MM-YYYY');
                        // row.encode_user_id = encodeURIComponent(row.user_id);
                        row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');
                    });
                    user_arr = rows[0];
                }else{
                    user_arr = [];
                }
                resolve(user_arr); // Resolve the promise with the rows
            }
        });
    });
    
    },
 
 //================ get all user start ============================
 async  getAllDeletedUsers() {
    return new Promise((resolve, reject) => {
        mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY user_id DESC) AS s_no,    um.user_id,    um.app_version,   um.unique_id,um.login_type,um.user_type,um.add_by_type,um.test_status,um.email,um.password,um.mobile,um.phone_code,um.f_name,um.l_name,um.name,um.user_name,um.dob,um.age,um.image,um.gender,um.address,um.latitude,um.longitude,um.state_id,um.city_id,um.zipcode,um.location_status,um.notification_status,um.otp,um.active_flag,um.profile_complete, um.approve_flag, um.createtime, um.country_id, um.country_name, um.delete_reason, IF(um.city_id = 0 OR cm.city_english IS NULL, "NA", CONCAT(cm.city_english, "(", cm.city_hindi, ")")) AS city_name,IF(um.state_id = 0 OR sm.state_english IS NULL, "NA", CONCAT(sm.state_english, "(", sm.state_hindi, ")")) AS state_name FROM  user_master um LEFT JOIN    city_master cm ON um.city_id = cm.city_id LEFT JOIN  state_master sm ON um.state_id = sm.state_id WHERE   um.delete_flag = 1  AND um.profile_complete = 2 and um.user_type=1 order by user_id desc', (error, rows) => {
            if (error) {
                console.log('database user get all error ')
                reject(error); // Reject the promise with the error
            } else {
                let user_arr='';
                if (rows.length > 0) {
                    rows.forEach(row => {
                        row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                        row.dob = moment(row.dob).format('DD-MM-YYYY');
                        row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');                        
                    });
                    user_arr = rows;
                }else{
                    user_arr = [];
                }
                resolve(user_arr); // Resolve the promise with the rows
            }
        });
    });
    
    },
//==============================
//================ check User function start ============================
  
async  checkUser(user_id) {
    return new Promise((resolve, reject) => {
        
         
        
        console.log(user_id)
        mysqlcon.query('SELECT user_id FROM user_master where delete_flag= 0   and user_id = ?',[user_id], (error, rows) => {
            if (error) {
                console.log('database user check error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.length > 0) {
                                     // Email exists, resolve with user_id
                    resolve(rows[0].user_id); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },
//================ update updateApproveUnapproveStatus  function start ============================
  
   async  updateApproveUnapproveStatus(approve_flag,user_id) {
    return new Promise((resolve, reject) => {
        const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');

        mysqlcon.query('UPDATE user_master SET approve_flag = ?,updatetime=? WHERE delete_flag=0 and  user_id = ? ',[approve_flag,updatetime,user_id], (error, rows) => {
            if (error) {
                console.log('database user check error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.affectedRows > 0) {
                                     // Email exists, resolve with user_id
                    resolve(rows.affectedRows); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },

//================ update updateActiveDeactiveStatus  function start ============================
  
   async  updateActiveDeactiveStatus(active_flag,user_id) {
    return new Promise((resolve, reject) => {
        const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');

        mysqlcon.query('UPDATE user_master SET active_flag = ?,updatetime=? WHERE delete_flag=0 and  user_id = ? ',[active_flag,updatetime,user_id], (error, rows) => {
            if (error) {
                console.log('database user check error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.affectedRows > 0) {
                                     // Email exists, resolve with user_id
                    resolve(rows.affectedRows); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },
//================ update delete_flag  function start ============================

  
   async  updateDeleteStatus(delete_flag,user_id) {
    return new Promise((resolve, reject) => {
        const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');

        mysqlcon.query('UPDATE user_master SET delete_flag = ?,updatetime=? WHERE  user_id = ? ',[delete_flag,updatetime,user_id], (error, rows) => {
            if (error) {
                console.log('database user check error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.affectedRows > 0) {
                                     // Email exists, resolve with user_id
                    resolve(rows.affectedRows); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },
//================ update updateSuspendedActiveStatus  function start ============================
  
   async  updateSuspendedActiveStatus(active_flag,user_id) {
    return new Promise((resolve, reject) => {
        const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');

        mysqlcon.query('UPDATE user_master SET active_flag = ?,updatetime=? WHERE delete_flag=0 and  user_id = ? ',[active_flag,updatetime,user_id], (error, rows) => {
            if (error) {
                console.log('database user check error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.affectedRows > 0) {
                                     // Email exists, resolve with user_id
                    resolve(rows.affectedRows); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },
//================ update updateSuspendedActiveStatus  function start ============================
  
   async  updateTestStatus(test_status,user_id) {
    return new Promise((resolve, reject) => {
        const updatetime = moment().format('YYYY-MM-DD HH:mm:ss');

        mysqlcon.query('UPDATE user_master SET test_status = ?,updatetime=? WHERE delete_flag=0 and  user_id = ? ',[test_status,updatetime,user_id], (error, rows) => {
            if (error) {
                console.log('database user check error ')
                reject(error);       // Reject the promise with the error
            } else {
                if (rows.affectedRows > 0) {
                                     // Email exists, resolve with user_id
                    resolve(rows.affectedRows); // Resolve with user_id
                } else {
                                      // Email does not exist, resolve with 0
                    resolve(0);       // Resolve with 0
                }
            }
        });
    });
    
    },
//================ update  User password function start ============================
 //================ get all Driver start ============================
 async  getAllDrivers() {
    return new Promise((resolve, reject) => {
        mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY user_id DESC) AS s_no,    um.user_id,    um.app_version,   um.unique_id,um.login_type,um.user_type,um.add_by_type,um.test_status,um.email,um.password,um.mobile,um.phone_code,um.f_name,um.l_name,um.name,um.user_name,um.dob,um.age,um.image,um.gender,um.address,um.latitude,um.longitude,um.state_id,um.city_id,um.zipcode,um.location_status,um.notification_status,um.otp,um.active_flag,um.profile_complete, um.approve_flag, um.createtime, um.country_id, um.country_name, um.delete_reason, IF(um.city_id = 0 OR cm.city_english IS NULL, "NA", CONCAT(cm.city_english, "(", cm.city_hindi, ")")) AS city_name,IF(um.state_id = 0 OR sm.state_english IS NULL, "NA", CONCAT(sm.state_english, "(", sm.state_hindi, ")")) AS state_name FROM  user_master um LEFT JOIN    city_master cm ON um.city_id = cm.city_id LEFT JOIN  state_master sm ON um.state_id = sm.state_id WHERE   um.delete_flag = 0  AND um.profile_complete = 2 and um.user_type=2 order by user_id desc', (error, rows) => {
            if (error) {
                console.log('database user get all error ')
                reject(error); // Reject the promise with the error
            } else {
                let user_arr='';
                if (rows.length > 0) {
                    rows.forEach(row => {
                        row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                        row.dob = moment(row.dob).format('DD-MM-YYYY');
                        // row.encode_user_id = encodeURIComponent(row.user_id);
                        row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');
                    });
                    user_arr = rows;
                }else{
                    user_arr = [];
                }
                resolve(user_arr); // Resolve the promise with the rows
            }
        });
    });
    
    },
    async  getViewDriver(user_id) {
        return new Promise((resolve, reject) => {
            mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY user_id DESC) AS s_no,    um.user_id,    um.app_version,   um.unique_id,um.login_type,um.user_type,um.add_by_type,um.test_status,um.email,um.password,um.mobile,um.phone_code,um.f_name,um.l_name,um.name,um.user_name,um.dob,um.age,um.image,um.gender,um.address,um.latitude,um.longitude,um.state_id,um.city_id,um.zipcode,um.location_status,um.notification_status,um.otp,um.active_flag,um.profile_complete, um.approve_flag, um.createtime, um.country_id, um.country_name, um.delete_reason, IF(um.city_id = 0 OR cm.city_english IS NULL, "NA", CONCAT(cm.city_english, "(", cm.city_hindi, ")")) AS city_name,IF(um.state_id = 0 OR sm.state_english IS NULL, "NA", CONCAT(sm.state_english, "(", sm.state_hindi, ")")) AS state_name FROM  user_master um LEFT JOIN    city_master cm ON um.city_id = cm.city_id LEFT JOIN  state_master sm ON um.state_id = sm.state_id WHERE   um.user_type=2 and user_id = ? ', [user_id],(error, rows) => {
                if (error) {
                    console.log('database user get all error ')
                    reject(error); // Reject the promise with the error
                } else {
                    let user_arr='';
                    if (rows.length > 0) {
                        rows.forEach(row => {
                            row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                            row.dob = moment(row.dob).format('DD-MM-YYYY');
                            // row.encode_user_id = encodeURIComponent(row.user_id);
                            row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');
                        });
                        user_arr = rows[0];
                    }else{
                        user_arr = [];
                    }
                    resolve(user_arr); // Resolve the promise with the rows
                }
            });
        });
        
        },
 //================ get all deleted Driver start ============================
 async  getAllDeletedDrivers() {
    return new Promise((resolve, reject) => {
        mysqlcon.query('SELECT  ROW_NUMBER() OVER (ORDER BY user_id DESC) AS s_no,    um.user_id,    um.app_version,   um.unique_id,um.login_type,um.user_type,um.add_by_type,um.test_status,um.email,um.password,um.mobile,um.phone_code,um.f_name,um.l_name,um.name,um.user_name,um.dob,um.age,um.image,um.gender,um.address,um.latitude,um.longitude,um.state_id,um.city_id,um.zipcode,um.location_status,um.notification_status,um.otp,um.active_flag,um.profile_complete, um.approve_flag, um.createtime, um.country_id, um.country_name, um.delete_reason, IF(um.city_id = 0 OR cm.city_english IS NULL, "NA", CONCAT(cm.city_english, "(", cm.city_hindi, ")")) AS city_name,IF(um.state_id = 0 OR sm.state_english IS NULL, "NA", CONCAT(sm.state_english, "(", sm.state_hindi, ")")) AS state_name FROM  user_master um LEFT JOIN    city_master cm ON um.city_id = cm.city_id LEFT JOIN  state_master sm ON um.state_id = sm.state_id WHERE   um.delete_flag = 1  AND um.profile_complete = 2 and um.user_type=2 order by user_id desc', (error, rows) => {
            if (error) {
                console.log('database user get all error ')
                reject(error); // Reject the promise with the error
            } else {
                let user_arr='';
                if (rows.length > 0) {
                    rows.forEach(row => {
                        row.createtime = moment(row.createtime).format('DD-MM-YYYY h:mm A');
                        row.dob = moment(row.dob).format('DD-MM-YYYY');
                        row.encode_user_id = Buffer.from(row.user_id.toString()).toString('base64');                        
                    });
                    user_arr = rows;
                }else{
                    user_arr = [];
                }
                resolve(user_arr); // Resolve the promise with the rows
            }
        });
    });
    
    },
  //=================================================user Analytical report==============
  
  //=================================================user Analytical report==============
    async getUserById(userId) {

        return new Promise((resolve, reject) => {
             mysqlcon.query('SELECT * FROM user_master WHERE user_id = ?', [userId], (error, rows) => {
                if (error) {
                    reject(error); // Reject the promise with the error
                } else {
                    resolve(rows[0]); // Resolve the promise with the rows
                }
            });
        });
      
    },
  
    // async addUser(data) {
    //   const { name, email } = data;
    //   const [result] = await mysqlcon.query('INSERT INTO user_master (name, email) VALUES (?, ?)', [name, email]);
    //   return result.insertId;
    // },
  
    // async updateUser(userId, updatedFields) {
    //   const { name, email } = updatedFields;
    //   await mysqlcon.query('UPDATE user_master SET name = ?, email = ? WHERE user_id = ?', [name, email, userId]);
    // },
  
    // async deleteUser(userId) {
    //   await mysqlcon.query('DELETE FROM user_master WHERE user_id = ?', [userId]);
    // },
   async getUserAnalyticalReports(type,current_year,current_month,get_by_type,user_type){
    return new Promise((resolve, reject) => {
        let where = '';
        if(type === 'monthly'){
            if(get_by_type === 'All'){
                where = ` AND user_type = ${user_type} AND YEAR(createtime) = ${current_year} AND MONTH(createtime) = ${current_month}`;
            } else if (get_by_type === 'delete'){
                where = ` AND user_type = ${user_type} AND delete_flag=1 AND YEAR(createtime) = ${current_year} AND MONTH(createtime) = ${current_month}`;
            } else if (get_by_type === 'active'){
                where = `AND delete_flag=0 AND user_type = ${user_type} AND active_flag=1 AND YEAR(createtime) = ${current_year} AND MONTH(createtime) = ${current_month}`;
            } else if (get_by_type === 'deactive'){
                where = ` AND user_type = ${user_type} AND active_flag=0 AND YEAR(createtime) = ${current_year} AND MONTH(createtime) = ${current_month}`;
            }

        }else{
            if(get_by_type === 'All'){
                where = ` AND user_type = ${user_type} AND YEAR(createtime) = ${current_year}`;
            } else if (get_by_type === 'delete'){
                where = ` AND user_type = ${user_type} AND delete_flag=1 AND YEAR(createtime) = ${current_year} `;
            } else if (get_by_type === 'active'){
                where = ` AND delete_flag=0 AND user_type = ${user_type} AND active_flag=1 AND YEAR(createtime) = ${current_year} `;
            } else if (get_by_type === 'deactive'){
                where = ` AND user_type = ${user_type} AND active_flag=0 AND YEAR(createtime) = ${current_year} `;
            }
        }
        // [year, month_number],
        mysqlcon.query('SELECT  user_id FROM user_master WHERE profile_complete = 2 '+ where + ' order by user_id desc', (error, rows) => {
            if (error) {
                console.log('database user get all error ')
                reject(error); // Reject the promise with the error
            } else {
                let user_arr=0;
                if (rows.length > 0) {
                    
                    user_arr = rows.length;
                }else{
                    user_arr = 0;
                }
                resolve(user_arr); // Resolve the promise with the rows
            }
        });
    });
   } ,
}
 // decodedata = parseInt(Buffer.from(encodedData, 'base64').toString()); 