const express = require('express');
const router = express.Router();
const AuthController = require('../controller/authController');
const UserController = require('../controller/userController');
const CommonController = require('../controller/commonController');

// ===================== Start Routes ===============================================

// ===================== Start Auth Controller Routes ===============================
router.post('/auth/sign_in', AuthController.signIn);
router.post('/auth/verify_token', AuthController.verifyToken);
router.post('/auth/updatepassword', AuthController.updatePassword);
router.post('/auth/forgotpassword', AuthController.verifyToken);
router.post('/auth/resetpassword', AuthController.verifyToken);
router.get('/auth/profile', AuthController.getProfile);
//========= single image upload route with uploadMiddleware =========================
router.post('/auth/editprofile',AuthController.uploadMiddleware.single('image'), AuthController.editProfile);
// ======================= end Auth Controller Routes ===============================

// ===================== Start user controller user routes Routes ========================
router.get('/user_controller/users', UserController.getAllUsers);
router.get('/user_controller/view_user', UserController.getViewUser);
router.get('/user_controller/deleted_users', UserController.getAllDeletedUsers);
router.get('/user_controller/users_analytical_report', UserController.getUserAnalyticalReports);
router.post('/user_controller/approve_unapprove_status', UserController.updateApproveUnapproveStatus);
router.post('/user_controller/active_deactive_status', UserController.updateActiveDeactiveStatus);
router.post('/user_controller/make_status_yes_no', UserController.updateTestStatus);
router.post('/user_controller/delete_user', UserController.updateDeleteStatus);


//========================================user controller driver Routes=================
router.get('/user_controller/drivers', UserController.getAllDrivers);
router.get('/user_controller/view_driver', UserController.getViewDriver);

router.get('/user_controller/deleted_drivers', UserController.getAllDeletedDrivers);
router.get('/user_controller/drivers_analytical_report', UserController.getDriverAnalyticalReports);

// ======================= end user controller  routes Routes ========================

// ======================= multiple images up routes Routes =========================

// ======================= multiple images up routes Routes =========================
//========================================CommonController contents Routes=================
router.get('/common_controller/contents', CommonController.getAllContent);
router.post('/common_controller/oneSignalNotificationSend', CommonController.oneSignalNotificationSend);
router.post('/common_controller/update_content', CommonController.updateContent);
router.get('/common_controller/contactus', CommonController.getAllContactus);
router.post('/common_controller/delete_contactus', CommonController.deleteContactus);
router.post('/common_controller/reply_contactus', CommonController.replyContactus);
//                       ==faq route ==              
router.post('/common_controller/add_faq', CommonController.addFaq);
router.post('/common_controller/update_faq', CommonController.updateFaq);
router.post('/common_controller/delete_faq', CommonController.deleteFaq);
router.get('/common_controller/get_faqs', CommonController.getAllFaqs);
// ======================= multiple images up routes Routes =========================
// router.post('/multiple', uploadControllerM.uploadMiddleware.array('image',5), uploadControllerM.handleFileUpload);
// ======================= multiple images up routes Routes =========================


// router.get('/sampleapp/admin/auth', UserController.AuthController);
// router.post('/', UserController.createUser);
// router.get('/:id', UserController.getUserById);
// router.put('/:id', UserController.updateUser);
// router.delete('/:id', UserController.deleteUser);
router.use((req, res, next) => {
    res.json({success:false ,msg: 'Invalid Routes!' });
  });
  
module.exports = router;
